/*
 smartctl.h - S.M.A.R.T. Control Header File 
 Author Michael Cornwel

  
Copyright  1999 The Regents of the University of California. 
All Rights Reserved. 

Permission to use, copy, modify, and distribute this software 
and its documentation for educational, research and non-profit 
purposes, without fee, and without a written agreement is hereby 
granted, provided that the above copyright notice, this 
paragraph and the following three paragraphs appear in all copies. 

Permission to incorporate this software into commercial products 
may be obtained by contacting the University of California 
at: Jan Lester,368 Applied Sciences Building, UCSC, Santa Cruz, 
CA 95064 (831) 459-4533. 

This software program and documentation are copyrighted by The 
Regents of the University of California. The software program 
and documentation are supplied "as is", without any accompanying 
services from The Regents. The Regents does not warrant that the
operation of the program will be uninterrupted or error-free. The 
end-user understands that the program was developed for research 
purposes and is advised not to rely exclusively on the program for 
any reason. 

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY 
PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL 
DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE 
AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA 
SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY
OF CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. 
*/


/* smartctl version number */
#define VERSION_MAJOR 1
#define VERSION_MINOR 2


/* Defines for command line options */ 
#define DRIVEINFO				'i'
#define CHECKSMART				'c'
#define SMARTVERBOSEALL			'a'
#define SMARTVENDORATTRIB		'v'
#define GENERALSMARTVALUES		'g'
#define SMARTERRORLOG			'l'
#define SMARTSELFTESTLOG		'L'
#define SMARTDISABLE			'd'
#define SMARTENABLE				'e'
#define SMARTEXEOFFIMMEDIATE	'O'
#define SMARTSHORTSELFTEST		'S'
#define SMARTEXTENDSELFTEST		'X'
#define SMARTSHORTCAPSELFTEST	's'
#define SMARTEXTENDCAPSELFTEST	'x'
#define SMARTSELFTESTABORT		'A'
#define SMARTAUTOOFFLINEENABLE  't'
#define SMARTAUTOOFFLINEDISABLE 'T'






/* Boolean Values */
#define TRUE 0x01
#define FALSE 0x00



/* Global Variables for command line options */
unsigned char driveinfo               = FALSE;
unsigned char checksmart              = FALSE;
unsigned char smartvendorattrib       = FALSE;
unsigned char generalsmartvalues      = FALSE;
unsigned char smartselftestlog        = FALSE;
unsigned char smarterrorlog           = FALSE;
unsigned char smartdisable            = FALSE;
unsigned char smartenable             = FALSE;
unsigned char smartstatus             = FALSE;
unsigned char smartexeoffimmediate    = FALSE;
unsigned char smartshortselftest      = FALSE;
unsigned char smartextendselftest     = FALSE;
unsigned char smartshortcapselftest   = FALSE;
unsigned char smartextendcapselftest  = FALSE;
unsigned char smartselftestabort      = FALSE;
unsigned char smartautoofflineenable  = FALSE;
unsigned char smartautoofflinedisable = FALSE;



