/* smartprint.h */
/*

Copyright  1999 The Regents of the University of California. 
All Rights Reserved. 

Permission to use, copy, modify, and distribute this software 
and its documentation for educational, research and non-profit 
purposes, without fee, and without a written agreement is hereby 
granted, provided that the above copyright notice, this 
paragraph and the following three paragraphs appear in all copies. 

Permission to incorporate this software into commercial products 
may be obtained by contacting the University of California 
at: Jan Lester,368 Applied Sciences Building, UCSC, Santa Cruz, 
CA 95064 (831) 459-4533. 

This software program and documentation are copyrighted by The 
Regents of the University of California. The software program 
and documentation are supplied "as is", without any accompanying 
services from The Regents. The Regents does not warrant that the
operation of the program will be uninterrupted or error-free. The 
end-user understands that the program was developed for research 
purposes and is advised not to rely exclusively on the program for 
any reason. 

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY 
PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL 
DAMAGES, INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE 
AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA 
SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY
OF CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS. 
*/

#ifndef _SMART_PRINT_H_
#define _SMART_PRINT_H_

#include <stdio.h>
#include "smart.h"


/* Print Formart of Structures for SMART information */


/* Prints ATA Drive Information and S.M.A.R.T. Capability */

void ataPrintDriveInfo (struct hd_driveid);




void ataPrintGeneralSmartValues (struct ata_smart_values);

void ataPrintSmartThresholds (struct ata_smart_thresholds);

void ataPrintSmartErrorlog ( struct ata_smart_errorlog);

void PrintSmartAttributes ( struct ata_smart_values data);

void PrintSmartAttribWithThres ( struct ata_smart_values data, 
		   						struct ata_smart_thresholds thresholds);

void ataPrintSmartSelfTestlog (struct ata_smart_selftestlog data);

void ataPsuedoCheckSmart ( struct ata_smart_values , struct ata_smart_thresholds );

/* Prints Attribute Name for standard SMART attributes */
/* prints 20 character string */
void ataPrintSmartAttribName (unsigned char id);

/* globals */

#endif
